local lighter = require("lighter")
local light

local function rndTriangle()
    local x = love.math.random(0,800)
    local y = love.math.random(0,600)
    local dx1 = love.math.random(50,100)*(love.math.random()-0.5 > 0 and 1 or -1)
    local dy1 = love.math.random(50,100)*(love.math.random()-0.5 > 0 and 1 or -1)
    local dx2 = love.math.random(50,100)*(love.math.random()-0.5 > 0 and 1 or -1)
    local dy2 = love.math.random(50,100)*(love.math.random()-0.5 > 0 and 1 or -1)
    return {x,y,x+dx1,y+dy1,x+dx2,y+dy2}
end

function love.load()
    love.graphics.setLineJoin("none")
    lighter:newWorld(800,600,{0,0,0,0.99})
    --lighter.debug = true
    light = lighter:addLight({
            x = 500,
            y = 300,
            r = 400,
            arc = math.pi/2,
            power = 0.5,
            color = {1,1,1}
            })
    light2 = lighter:addLight({
            x = 100,
            y = 300,
            r = 400,
            power = 0.5,
            color = {1,0,0}
        })
    light2 = lighter:addLight({
            x = 600,
            y = 300,
            r = 400,
            power = 0.5,
            color = {0,1,0}
        })
    light3 = lighter:addLight({
            x = 400,
            y = 500,
            r = 400,
            power = 0.5,
            color = {0,0,1}
            })
    for i = 1,10 do
        lighter:addPolygon(rndTriangle())
    end
    love.graphics.setBackgroundColor(1,1,1,1)
    love.graphics.setDefaultFilter("nearest","nearest")
    bg = love.graphics.newImage("love-ball.png")
end

function love.update(dt)
end
r = 0
function love.draw()
    love.graphics.setColor(1,1,1)
    r = r + 0.01
    love.graphics.draw(bg,400,300,r,5,5,32,32)
    lighter:draw()
    lighter:debugObj()
    love.graphics.print(love.timer.getFPS())
    love.graphics.print("hold none/lctrl/lalt/lshift + wheel to test",0,20)
end

function love.mousemoved(x,y,dx,dy)
    light.x,light.y = x,y
end

function love.wheelmoved(dx,dy)
    if love.keyboard.isDown("lctrl") then
        light.arc = light.arc + dy*0.1
    elseif love.keyboard.isDown("lalt") then
        light.r = light.r + dy*10
    elseif love.keyboard.isDown("lshift") then
        light.power = light.power +dy*0.05
    else
        light.dir = light.dir + dy*0.1
    end
end